<script lang="ts" setup>
import { ref } from 'vue';
import { SEARCH_FILTER_OPTIONS } from '~/services/search.service';
import type { BaseLink } from '@/types/base';
import { Close } from 'slippers-ui/icons';
interface pageContentProps {
  filter: {
    filterText: string;
    sourceText: string;
  };
  login: {
    text: string;
    button: BaseLink;
  };
  close: string;
}
interface searchCountProps {
  marketing: number;
  blog: number;
  handbook: number;
}
interface SearchFilterProps {
  initialFilter: string;
  searchCount: searchCountProps;
  isMobileOpen: boolean;
  pageContent: pageContentProps;
}

// Emits
const emit = defineEmits(['filterSelect', 'close']);

// Props
const props = defineProps<SearchFilterProps>();

// Reactive Data
const filterOptions = ref(SEARCH_FILTER_OPTIONS);
const searchType = props.initialFilter;

// Methods
const onSelectSearchType = (searchType: string) => {
  emit('filterSelect', searchType);
};
const onClose = () => {
  emit('close');
};
</script>

<template>
  <div class="search-filter" :class="{ 'search-filter--mobile': isMobileOpen }">
    <div class="search-filter__close">
      <SlpButton variant="ghost" @click="onClose">
        <SlpTypography variant="body3" class="close-text">{{ pageContent?.close }}</SlpTypography>
        <SlpIcon :icon="Close" size="lg" class="slp-mr-16" />
      </SlpButton>
    </div>
    <div class="search-filter__header">
      <SlpTypography tag="h5" variant="body1-bold">{{
        isMobileOpen ? pageContent?.filter?.filterText : pageContent?.filter?.sourceText
      }}</SlpTypography>
    </div>
    <div class="slp-flex slp-flex-column">
      <div v-for="option in filterOptions" :key="option.value" class="search-filter__option">
        <SlpRadioButton
          :option="option.name"
          name="filterType"
          :config="{ checked: option.value === searchType }"
          @update:model-value="onSelectSearchType(option.value)"
        />

        <span v-if="searchCount">({{ searchCount[option.value].toLocaleString() }})</span>
        <SlpTypography v-if="option.page" tag="p" variant="body2" class="slp-color-text-200 slp-ml-32 slp-mt-8">{{
          option.page
        }}</SlpTypography>
      </div>
    </div>
    <div class="search-filter__footer">
      <SlpTypography tag="p" variant="body3" class="slp-mb-8"> {{ pageContent?.login?.text }} </SlpTypography>
      <SlpButton
        :href="pageContent?.login?.button?.config?.href"
        target="_blank"
        :data-ga-location="pageContent?.login.button.config.dataGaLocation"
        :data-ga-name="pageContent?.login.button.config.dataGaName"
      >
        {{ pageContent?.login?.button?.text }}
      </SlpButton>
    </div>
  </div>
</template>

<style lang="scss" scoped>
$border-color: 1px solid $color-surface-300;

.search-filter {
  display: none;
  border: $border-color;
  max-width: 255px;

  @media (min-width: $breakpoint-md) {
    display: block;
  }

  &--mobile {
    display: block;
    max-width: unset;
    position: fixed;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    background-color: white;
    padding: 0 $spacing-16;
    margin: 0 (-$spacing-16);
    overflow: hidden;
    z-index: $zindex-tooltip;
  }

  &__close {
    display: flex;
    justify-content: flex-end;
    padding: $spacing-8;
    color: $color-text-300;

    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }

  &__header {
    padding: $spacing-16;
    border-bottom: $border-color;
    border-top: $border-color;

    @media (min-width: $breakpoint-md) {
      border-top: unset;
    }
  }

  &__option {
    padding: $spacing-16;
    border-bottom: $border-color;

    &:deep(.slp-radio) {
      margin-bottom: 0;
    }
  }

  &__footer {
    display: none;
    padding: $spacing-16;

    @media (min-width: $breakpoint-md) {
      display: block;
    }

    &:deep(.slp-btn) {
      background-color: white;
      width: 100%;
      justify-content: center;
      color: $color-primary-200;

      &:hover {
        background-color: $color-primary-200;
        color: white;
      }
    }
  }
}
</style>
